unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, IniFiles;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
   CgiIniFile : TIniFile;
   CgiIniFileName : String;
   OutputFile : TextFile;
   OutputFileName : String;
   RequestMethod : String;
   ServerName : String;
   RemoteAddress : String;

begin
   CgiIniFile := TIniFile.Create(ParamStr(1));
   application.processMessages;

   OutputFileName := CgiIniFile.ReadString('System', 'Output File', '');

   {Retrieve the three data items that we want for this examples:
   Request Method, Server Name, and the Users IP Address/Remote Address}

   RequestMethod := CgiIniFile.ReadString('CGI', 'Request Method', '');
   ServerName := CgiIniFile.ReadString('CGI', 'Server Name', '');
   RemoteAddress := CgiIniFile.ReadString('CGI', 'Remote Address', '');

   CgiIniFile.Free;

   AssignFile( OutputFile, OutputFileName);
   ReWrite(OutputFile);

   Writeln(OutputFile, 'HTTP/1.0 200 OK');
   Writeln(OutputFile, 'Date: Thursday, 12-Jan-96 16:04:30 GMT');
   Writeln(OutputFile, 'Server: WebSite 1.0');
   Writeln(OutputFile, 'Content-type: text/html');
   Writeln(OutputFile, 'Last-modified: Thursday, 25-Jan-96 16:04:30 GMT');
   Writeln(OutputFile, 'Content-length: 5000');
   Writeln(OutputFile, '');
   Writeln(OutputFile, '<HTML><HEAD>');
   Writeln(OutputFile, '<TITLE>Example Two</TITLE></HEAD>');
   Writeln(OutputFile, '<BODY BGCOLOR="#FFFFFF"><HR>Hello Again World, <P>');
   Writeln(OutputFile, 'The Request Method is <B>' + RequestMethod + '</B>.<BR>');
   Writeln(OutputFile, 'The Server Name is <B>' + ServerName + '</B>.<BR>');
   Writeln(OutputFile, 'Your IP Address is <B>' + RemoteAddress + '</B>.<P>');

   Writeln(OutputFile, 'Sir, the time on deck is <B>' + DateTimeToStr(Now) + '</B><P><HR>');
   
   Writeln(OutputFile, '</BODY></HTML>');

   CloseFile(OutputFile);

   Halt;


end;

end.
