unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, IniFiles;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
   CgiIniFile : TIniFile;
   CgiIniFileName : String;
   OutputFile : TextFile;
   OutputFileName : String;
   RequestMethod : String;
   ServerName : String;
   RemoteAddress : String;
   FirstName : String;
   LastName : String;
   TypePerson : String;

begin
   CgiIniFile := TIniFile.Create(ParamStr(1));
   application.processMessages;

   OutputFileName := CgiIniFile.ReadString('System', 'Output File', '');

   {Retrieve the three data items that we want for this example:
   Request Method, Server Name, Users IP Address/Remote Address,
   and the form data}

   RequestMethod := CgiIniFile.ReadString('CGI', 'Request Method', '');
   ServerName := CgiIniFile.ReadString('CGI', 'Server Name', '');
   RemoteAddress := CgiIniFile.ReadString('CGI', 'Remote Address', '');

   {The form data that we are retrieving resides in the Form Literal Section.
    We have to know something about the HTML that defines each field,
    specifically the name="xxx".  We use the xxx to find the right entry.}

   FirstName := CgiIniFile.ReadString('Form Literal', 'firstname', '');
   LastName := CgiIniFile.ReadString('Form Literal', 'lastname', '');
   TypePerson := CgiIniFile.ReadString('Form Literal', 'typeperson', '');

   CgiIniFile.Free;

   AssignFile( OutputFile, OutputFileName);
   ReWrite(OutputFile);

   Writeln(OutputFile, 'HTTP/1.0 200 OK');
   Writeln(OutputFile, 'Date: Thursday, 12-Jan-96 16:04:30 GMT');
   Writeln(OutputFile, 'Server: WebSite 1.0');
   Writeln(OutputFile, 'Content-type: text/html');
   Writeln(OutputFile, 'Last-modified: Thursday, 25-Jan-96 16:04:30 GMT');
   Writeln(OutputFile, 'Content-length: 5000');
   Writeln(OutputFile, '');
   Writeln(OutputFile, '<HTML><HEAD>');
   Writeln(OutputFile, '<TITLE>Example Two</TITLE></HEAD>');
   Writeln(OutputFile, '<BODY BGCOLOR="#FFFFFF"><HR>Hello ' + FirstName + ' ' + LastName + ', <P>');
   Writeln(OutputFile, 'The Request Method is <B>' + RequestMethod + '</B>.<BR>');
   Writeln(OutputFile, 'The Server Name is <B>' + ServerName + '</B>.<BR>');
   Writeln(OutputFile, 'Your IP Address is <B>' + RemoteAddress + '</B>.<P>');

   Writeln(OutputFile, 'Sir, the time on deck is <B>' + DateTimeToStr(Now) + '</B><P><HR>');

   Writeln(OutputFile, 'You are a really <B>' + TypePerson + '</B> individual.');


   Writeln(OutputFile, '</BODY></HTML>');

   CloseFile(OutputFile);

   Halt;

end;

end.
