unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, Wincgi;

type
  TForm1 = class(TForm)
    WinCGI: TWinCGI;
    Query1: TQuery;
    Query1FIRSTNAME: TStringField;
    Query1LASTNAME: TStringField;
    Query1TYPEPERSON: TStringField;
    Query1GENDER: TStringField;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
   res : Boolean;      {Check the return value of our methods}
   criteria : String;

begin
with WinCGI do
begin
   InitWinCGI;

   criteria := GetLiteral('gender');

   {This is where we set the parameter up for the TQuery
    that will determine whether we pull the male or
    female records}
   with Query1 do
   begin
        close;
        ParamByName('gend').AsString := criteria;
        open;
   end;

   SendHTTPHeader; {Method that sends 5 lines to the server,
                    including a properly formatted GMT line
                    and a line that reads the WebServerName
                    property from our component}

   Send('<HTML><HEAD>');     {Writes a line to output file}
   Send('<TITLE>Example Eight</TITLE></HEAD>');

   {If we're showing Males, then send a blue background,
    If we're showing Females, then send a pink background.}
   if criteria = 'Male' then
      Send('<BODY BGCOLOR="#0000FF"><HR>')
   else
      Send('<BODY BGCOLOR="#BC8F8F"><HR>');

   Send('<H2>Using Our Delphi Component!</H2>');
   Send('<CENTER><H2>A List of ' + criteria + 's</H2><CENTER>');


   {Here's where we get a little fancy and will
    loop through the records and put them in a
    table -- A dynamic Page!!}
   if Query1.EOF then
   begin
        Send('<H2>Sorry!</H2>');
        Send('Couldn''t find anyone in the database that is a <B>' + criteria + '</B><P>');
        Send('Click the BACK button on your browser and try again.<P>');
   end
   else
   begin
        Send('<CENTER><TABLE BORDER>');
        send('<TR>');
        send('<TH>First Name');
        send('<TH>Last Name');
        send('<TH>Person Type');

        while not Query1.EOF do
        begin
        send('<TR>');
        send('<TD>' + Query1FIRSTNAME.Value);
        send('<TD>' + Query1LASTNAME.Value);
        send('<TD>' + Query1TYPEPERSON.Value);
        Query1.Next;
        end;
        send('</TABLE></CENTER>');
   end;

   Send('Sir, the time on deck is <B>' + DateTimeToStr(Now) + '</B><P><HR>');
   Send('</BODY></HTML>');

   CloseWinCGI; {Method that closes the output File}

   Halt; {Stops the program.  The Web Server takes control and
          delivers the output file to the user.}
end;

end;

end.
