unit Ddeunit;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DdeMan, StdCtrls, ExtCtrls, Buttons;

type
  Directions = ( dUp, dDown, dLeft, dRight );

  TForm1 = class(TForm)
    NetscapeDDE: TDdeClientConv;
    DownBtn: TBitBtn;
    LeftBtn: TBitBtn;
    UpBtn: TBitBtn;
    RightBtn: TBitBtn;
    Bevel1: TBevel;
    Label1: TLabel;
    LoadBtn: TButton;
    URLEdit: TEdit;
    procedure LoadBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DirBtnClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
    WindowId : LongInt;
    Direction : Directions;
    Procedure MoveBrowser;
    Procedure ActivateBrowser;
    procedure WMMove( var Message: TWMMove ); message WM_MOVE;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.LoadBtnClick(Sender: TObject);

begin
  if NetscapeDDE.SetLink( 'NETSCAPE', 'WWW_OpenURL' )
  then Begin
     NetscapeDDE.RequestData( URLEdit.Text + ',,0xFFFFFFFF,0x1,,,,' );
     ActivateBrowser;
  End;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   WindowId := -1;
   Direction := dDown;
   ActivateBrowser;
end;

procedure TForm1.ActivateBrowser;

Type
   LongPtr = ^LongInt;

Var
   Window : LongInt;
   Result : LongPtr;

Begin
   If NetscapeDDE.SetLink( 'NETSCAPE', 'WWW_Activate' )
   Then Begin
      Result := LongPtr( NetscapeDDE.RequestData( '0xffffffff,0x0' ) );
      WindowId := Result^;
      UpBtn.Enabled := WindowId <> -1;
      DownBtn.Enabled := WindowId <> -1;
      LeftBtn.Enabled := WindowId <> -1;
      RightBtn.Enabled := WindowId <> -1;
      MoveBrowser;
   End;
End;

procedure TForm1.MoveBrowser;

Var
   NewX, NewY, NewWidth, NewHeight : Integer;

Begin
   If WindowId <= 0
   Then
      exit;
   Case Direction of
      dUp : Begin
         NewX := Left;
         NewWidth := Screen.Width - Left;
         NewY := 0;
         NewHeight := Top - 1;
      End;
      dDown : Begin
         NewX := Left;
         NewWidth := Screen.Width - Left;
         NewY := Top + Height;
         NewHeight := Screen.Height - NewY;
      End;
      dLeft : Begin
         NewX := 0;
         NewWidth := Left - 1;
         NewY := Top;
         NewHeight := Screen.Height - Top;
      End;
      dRight : Begin
         NewX := Left + Width;
         NewWidth := Screen.Width - NewX;
         NewY := Top;
         NewHeight := Screen.Height - Top;
      End;
   End;

   {Normalize the window in case its minimized}
   if NetscapeDDE.SetLink( 'NETSCAPE', 'WWW_WindowChange' )
   Then
      NetscapeDDE.PokeData( IntToStr( WindowId ) + ',0x00000004', '' );

   if NetscapeDDE.SetLink( 'NETSCAPE', 'WWW_WindowChange' )
   Then
      NetscapeDDE.PokeData(
          IntToStr( WindowId )   + ',' +
             '0x00000001'           + ',' +
             IntToStr( NewX )       + ',' +
             IntToStr( NewY )       + ',' +
             IntToStr( NewWidth )   + ',' +
             IntToStr( NewHeight ),
          '' );


End;


procedure TForm1.DirBtnClick(Sender: TObject);
begin
   If Sender = UpBtn
   Then
      Direction := dUp
   Else If Sender = DownBtn
   Then
      Direction := dDown
   Else If Sender = LeftBtn
   Then
      Direction := dLeft
   Else
      Direction := dRight;
   MoveBrowser;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
   MoveBrowser;
end;

procedure TForm1.WMMove( var Message: TWMMove );

Begin
   Inherited;
   MoveBrowser;
End;

end.
