unit OLEUnit;

interface

uses Windows, Classes, Dialogs, Forms, Controls,
  StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    LoadURLBtn: TButton;
    URL: TEdit;
    Length: TEdit;
    LoadStatusBar: TProgressBar;
    URLData: TRichEdit;
    URLLbl: TLabel;
    LoadLbl: TLabel;
    procedure LoadURLBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    public
       Navigator : Variant;
       LeftOver, Buffer : String;
       Finished : Boolean;
       Procedure BufferToRichEdit;
  end;

var
  Form1: TForm1;

implementation

uses
    OleAuto,
    SysUtils;

{$R *.DFM}

Procedure TForm1.BufferToRichEdit;

Const
   CR = #13;
   LF = #10;

Var
   S : String;
   I : Integer;
   FoundCR : Boolean;

Begin
   Buffer := LeftOver + Buffer;
   LeftOver := '';
   While Buffer <> ''
   Do Begin
      I := Pos( CR, Buffer );
      FoundCR := I <> 0;
      If Not FoundCR
      Then
         I := Pos( LF, Buffer );
      If I = 0
      Then Begin
         If Finished
         Then Begin
            S := Buffer;
            Buffer := '';
         End
         Else Begin
            LeftOver := Buffer;
            Exit;
         End;
      End
      Else Begin
         S := Copy( Buffer, 1, I - 1 );
         Delete( Buffer, 1, I );
         If FoundCR And ( Buffer <> '' ) And ( Buffer[ 1 ] = LF )
         Then
            Delete( Buffer, 1, 1 );
      End;
      URLData.Lines.Add( S );
   End;
End;


procedure TForm1.LoadURLBtnClick(Sender: TObject);

Const
   BuffSize  = 512;

var
  BytesRead, ContentLength, TotalRead : Integer;

begin
  Cursor := crHourGlass;
  LeftOver := '';
  Finished := False;
  LoadURLBtn.Enabled := False;
  ContentLength := 0;
  Length.Text := '';
  LoadStatusBar.Position := 0;
  URLData.Lines.Clear;

  If Navigator.Open( URL.Text, 0, '', 0, '' )
  Then begin
     SetLength( Buffer, BuffSize );
     BytesRead := Navigator.Read( Buffer, BuffSize );
     While BytesRead <> -1
     Do Begin
        If ( ContentLength = 0 )
        Then Begin
           ContentLength := Navigator.GetContentLength;
           Length.Text := IntToStr( ContentLength );
        End;
        If BytesRead <> 0
        Then Begin
           SetLength( Buffer, BytesRead );
           Inc( TotalRead, BytesRead );
           BufferToRichEdit;
           If ContentLength <> 0
           Then
              LoadStatusBar.Position := TotalRead * 100 Div ContentLength;
        End;
        Application.ProcessMessages;
        SetLength( Buffer, BuffSize );
        BytesRead := Navigator.Read( Buffer, BuffSize );
     End;
     Finished := True;
     Buffer := '';
     BufferToRichEdit;
  End;
  Navigator.Close;
  Cursor := crDefault;
  LoadURLBtn.Enabled := True;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  try
    Navigator := CreateOleObject( 'Netscape.Network.1' );
  except
    ShowMessage( 'Unable to start the Netscape Navigator' );
    LoadURLBtn.Enabled := False;
  end;
end;

end.
