unit Asyncfrm;

interface

uses
  SysUtils, WinTypes, dWinsock,
  Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Header1: THeader;
    ClientSocket1: TBasicClientSocket;
    Label3: TLabel;
    procedure ClientSocket1Info(Sender: TObject; icode: TSockInfo;
      Socket: TSocketBase);
    procedure ClientSocket1AsyncComplete(Sender: TObject;
      AsyncInfo: tAsyncInfo);
    procedure Button1Click(Sender: TObject);
    procedure ClientSocket1TimeOut(Sender: TObject; Socket: TSocketBase);
  private
    AsyncID: tHandle;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ClientSocket1Info(Sender: TObject; icode: TSockInfo;
  Socket: TSocketBase);
begin
  Header1.Sections[0] :=  SockInfoToString( iCode );
end;

procedure TForm1.ClientSocket1AsyncComplete(Sender: TObject;
  AsyncInfo: tAsyncInfo);
begin
  Header1.Sections[0] := 'Lookup Complete';
  if AsyncInfo.TaskHandle = AsyncID then
    with (AsyncInfo as tAsyncHostInfo) do
    begin
      if Error = 0 then
        Edit2.Text := Address
      else
        Edit2.Text := ErrorStr(Error);
    end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  AsyncID := ClientSocket1.AsyncLookupHostByName(Edit1.Text);
  Header1.Sections[0] := format('AsyncLookupHostByName in progress (%d)',[AsyncID]);
  { AsyncID is important if you make more than one Async call at a time }
end;

procedure TForm1.ClientSocket1TimeOut(Sender: TObject;
  Socket: TSocketBase);
begin
  Header1.Sections[0] := format('AsyncLookupHostByName TimedOut',[AsyncID]);
end;

end.
