unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, dWinsock, buffsock;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ServerEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    URIEdit: TEdit;
    Label3: TLabel;
    HttpClient: TBinaryClient;
    Label4: TLabel;
    Memo1: TMemo;
    MethodComboBox: TComboBox;
    Label5: TLabel;
    Label6: TLabel;
    PortEdit: TEdit;
    s: TTextServer;
    procedure HttpClientDisconnect(Sender: TObject; Socket: TSocketBase);
    procedure HttpClientConnect(Sender: TObject; Socket: TSocketBase);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sLineReceived(socket: TLineSocketBase; const line: String;
      complete: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure HTTPWriteLine( sock : TSocketBase; s : string);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.HttpClientDisconnect(Sender: TObject;
  Socket: TSocketBase);
var
  p : PChar;
  sz : Integer;
begin
  sz := (Socket as TBufferedSocket).ReadBufferBytesUsed + 1;
  if sz <= 1 then Exit;

  p := StrAlloc(sz);
  try
    Fillchar( p^, sz, #0);
    (Socket as TBufferedSocket).ReadFromBuffer( p^, sz);
    Memo1.SetTextBuf(p);
  finally
    StrDispose(p);
  end;
  Socket.Close;
end;

procedure TForm1.HTTPWriteLine( sock : TSocketBase; s : string);
begin
  if Length(s) > 0 then
    (sock as TBufferedSocket).WriteBlockToBuffer( PChar(@s[1])^, Length(s));
  (sock as TBufferedSocket).WriteBlockToBuffer( PChar(#13#10)^, 2);
end;

procedure TForm1.HttpClientConnect(Sender: TObject; Socket: TSocketBase);
begin
  if Socket.LastError = 0 then
  begin

    HTTPWriteLine( Socket,
      Format( '%s %s HTTP/1.0', [MethodComboBox.Text, URIEdit.Text]));
    HTTPWriteLine( Socket, '');
    (Socket as TBufferedSocket).SendBuffer;

  end else Memo1.Lines.Add( 'Connect error '+ErrorStr(Socket.LastError));
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Memo1.Lines.Clear;
  HttpClient.Address := ServerEdit.Text;
  HttpClient.Port := PortEdit.Text;
  HttpClient.Open( TBufferedSocket);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
s.listen(tlinesocket);
end;

procedure TForm1.sLineReceived(socket: TLineSocketBase; const line: String;
  complete: Boolean);
begin
(socket as tlinesocket).WriteLine(line);
(socket as tlinesocket).close;
end;

end.
