unit climain;

interface

uses
  WinProcs, WinTypes, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, dWinsock, StdCtrls, BuffSock;

type
  TForm1 = class(TForm)
    SendEdit: TEdit;
    Button1: TButton;
    HostEdit: TEdit;
    Label1: TLabel;
    Button2: TButton;
    ClientSocket1: TBasicClientSocket;
    Button3: TButton;
    Panel1: TPanel;
    Label2: TLabel;
    ResponseEdit: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure ClientSocket1Info(Sender: TObject; icode: TSockInfo;
      Socket: TSocketBase);
    procedure ClientSocket1Connect(Sender: TObject; Socket: TSocketBase);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TSocketBase);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure LineReceived(
      Sender : TLineSocketBase; const line : string; complete : Boolean);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if not ClientSocket1.Conn.Connected then
  begin
    Button1.Caption := 'Disconnect';
    ClientSocket1.Address := HostEdit.Text;
    ClientSocket1.Open( TLineSocket);
  end else
  begin
    Button2.Enabled := False;
    ClientSocket1.Close;
    Button1.Caption := 'Connect';
  end;
end;

procedure TForm1.ClientSocket1Info(Sender: TObject; icode: TSockInfo;
  Socket: TSocketBase);
begin
  Panel1.Caption := SockInfotoString(icode);
end;

procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TSocketBase);
begin
  if Socket.LastError = 0 then
  begin
    Button2.Enabled := True;
    (Socket as TLineSocket).OnLineReceived := LineReceived;
  end;
end;

procedure TForm1.ClientSocket1Disconnect(Sender: TObject;
  Socket: TSocketBase);
begin
  Button2.Enabled := False;
end;

procedure TForm1.LineReceived(
  Sender : TLineSocketBase; const line : string; complete : Boolean);
begin
{ for Delphi 1 you must call RebuildLongLine if 'complete' is False }
  ResponseEdit.Text := line;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  (ClientSocket1.Conn as TLineSocket).WriteLine( SendEdit.Text);
end;

end.
