unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Buttons, Menus, dWinsock, buffsock, StdCtrls;

type
  TMainForm = class(TForm)
    BinaryClient1: TBinaryClient;
    BinaryServer1: TBinaryServer;
    Panel1: TPanel;
    Panel2: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    SendBitmap1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Image1: TImage;
    StatusPanel: TPanel;
    procedure Exit1Click(Sender: TObject);
    procedure BinaryServer1FileReceived(socket: TBufferedSocketBase);
    procedure BinaryClient1FileSent(socket: TBufferedSocketBase);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure BinaryClient1Connect(Sender: TObject; Socket: TSocketBase);
    procedure BinaryServer1ReadBufferChange(socket: TBufferedSocketBase);
    procedure BinaryServer1Disconnect(Sender: TObject;
      Socket: TSocketBase);
    procedure BinaryClient1Info(Sender: TObject; icode: TSockInfo;
      Socket: TSocketBase);
    procedure BinaryClient1WriteBufferChange(socket: TBufferedSocketBase);
    procedure BinaryServer1Accept(Sender: TObject; Socket: TSocketBase);
  private
    { Private declarations }
    FInBitmapStream : TMemoryStream;
    FPictureSent : Boolean;
  public
    { Public declarations }
    procedure KillInStream;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}
uses Unit2, dWSUtils;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.BinaryServer1FileReceived(socket: TBufferedSocketBase);
begin
  FInBitmapStream.Position := 0; { seek to start of stream }
  Image1.Picture.Bitmap.LoadFromStream( FInBitmapStream);
  KillInStream;
end;

procedure TMainForm.BinaryClient1FileSent(socket: TBufferedSocketBase);
begin
  FPictureSent := True;
  StatusPanel.Caption := 'Picture sent!';
  Socket.Close;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  ShowMessage(
    'Run this demo on two computers at once for the best results. '#13#13+
    'Just locate a BMP file and enter the IP address of another machine running '+
    'this program... use 127.0.0.1 to send them to yourself.');
  BinaryServer1.Listen( TBufferedSocket);
end;

procedure TMainForm.SpeedButton2Click(Sender: TObject);
begin
  FPictureSent := False;
  if SendPictureForm.ShowModal = mrOK then
  begin
    BinaryClient1.Address := SendPictureForm.ServerEdit.Text;
    BinaryClient1.Open( TBufferedSocket);
  end;
end;

procedure TMainForm.BinaryClient1Connect(Sender: TObject;
  Socket: TSocketBase);
var
  streamsz : Longint;
begin
  if Socket.LastError = 0 then
  begin
    with Socket as TBufferedSocket do
    begin
      streamsz := WinsockAPI.ntohl(
        GetFileSize(SendPictureForm.PictureEdit.Text));
      WriteToBuffer( streamsz, SizeOf(Longint));
      SendFile( SendPictureForm.PictureEdit.Text);
      SendBuffer;
    end;
  end else ShowMessage( 'Connection error - '+ErrorStr(Socket.LastError));
end;

procedure TMainForm.BinaryServer1ReadBufferChange(
  socket: TBufferedSocketBase);
var
  streamsz : Longint;
begin
  with Socket as TBufferedSocket do
  begin
    if FInBitmapStream = nil then
    begin
      if ReadBufferBytesUsed > SizeOf(Longint) then
      begin
        ReadFromBuffer( streamsz, SizeOf(Longint));
        streamsz := WinsockAPI.ntohl(streamsz);
        FInBitmapStream := TMemoryStream.Create;
        FInBitmapStream.SetSize(streamsz);
        RecvStream( FInBitmapStream, streamsz, False);
      end;
    end;

    if ReceivingStream then
      StatusPanel.Caption :=
        Format( 'Received %d of %d bytes', [RecvStreamPos, RecvStreamSize]);
  end;
end;

procedure TMainForm.KillInStream;
begin
  if Assigned(FInBitmapStream) then
  begin
    FInBitmapStream.Free;
    FInBitmapStream := nil;
  end;
end;

procedure TMainForm.BinaryServer1Disconnect(Sender: TObject;
  Socket: TSocketBase);
begin
  { In case the transfer failed }
  KillInStream;
  Socket.Close;
  StatusPanel.Color := clBtnFace;
  StatusPanel.Caption := '';
end;

procedure TMainForm.BinaryClient1Info(Sender: TObject; icode: TSockInfo;
  Socket: TSocketBase);
begin
  {StatusPanel.Caption := SockInfoToString( icode);}
end;

procedure TMainForm.BinaryClient1WriteBufferChange(
  socket: TBufferedSocketBase);
begin
  with Socket as TBufferedSocket do
  begin
    if SendingStream then
      StatusPanel.Caption :=
        Format( 'Sent %d of %d bytes', [SendStreamPos, SendStreamSize]);
  end;
end;

procedure TMainForm.BinaryServer1Accept(Sender: TObject;
  Socket: TSocketBase);
begin
  StatusPanel.Color := clGray;
end;

end.
