(*****************************************************************************
 * dWinsock component for Borland Delphi.
 *
 * (C) 1995 by Ulf Sderberg, ulfs@sysinno.se
 *             Marc Palmer,   marc@anyware.co.uk
 *             Keith Hawes,   khawes@ccmail.com
 *
 *  dwsError.pas - Constants for winsock & dWinsock errors.
 *
 *
 * $Revision:   1.7  $
 *
 * -- History --
 * $Log:   //SUPPORT_SYSTEMS/PVCS/Source/DWSERROR._PAS  $
 * 
 *    Rev 1.7   25 Apr 1997 15:18:40   khawes
 * 
 *    Rev 1.6   14 Mar 1997 16:17:34   khawes
 * Added new TBinaryClient/Server and TTextCient/Server Components
 * 
 * 
 *    Rev 1.5   23 Oct 1996 12:48:28   khawes
 * Fix Bug with changing the offset for registry variables.  Also moved Resources 
 * to not conflice with Async Pro by Default.
 * 
 * 
 *    Rev 1.4   21 Aug 1996 08:45:22   KHAWES
 * Put Offset constant back to 0
 * 
 * 
 *    Rev 1.3   21 Aug 1996 08:40:54   KHAWES
 * Fix error message Offset bug.
 * 
 *
 *    Rev 1.2   05 Aug 1996 11:35:42   KHAWES
 * (MP) New Error Messages for stream types
 * 
 *
 *    Rev 1.1   29 May 1996 16:51:10   KHAWES
 * Add ability to change the string resource values so that users can resolve any
 * resource conflicts that may arrise.
 *
 *
 *    Rev 1.0   29 Mar 1996 09:59:44   khawes
 * Begin PVCS version controll
 *
 *
 *****************************************************************************)
unit dwsError;

interface
{$ifdef WIN32}
  {$R dwsErr32.RES}
{$Else}
  {$R dwsError.RES}
{$endif}


const
  WSAOffset       =  5000;  { Change this to move Error string resources  }
  { NOTICE: Don't forget to recompile the RC file into the RES after you  }
  { change the above value!  You can use doresdcr.bat                     }

{$ifdef BRCC32}  {Will never be defined for Delphi}
#ifdef skip
{$endif}

  WSAOffsetDelphi = WSAOffset;   { Constants must not be adjusted for Delphi }

{$ifdef BRCC32}  {Will never be defined for Delphi}
#endif

  WSAOffsetDelphi = 0;           { Constants need to be Adjusted for BRCC    }
{$endif}

  { Do NOT change these numbers }
  WSABASEERR         =  (10000 + WSAOffset - WSAOffsetDelphi);
  DWSBaseErr         =  (20000 + WSAOffset - WSAOffsetDelphi);

  WSAEINTR           =  (WSABASEERR + 4);
  WSAEBADF           =  (WSABASEERR + 9);
  WSAEACCES          =  (WSABASEERR + 13);
  WSAEFAULT          =  (WSABASEERR + 14);
  WSAEINVAL          =  (WSABASEERR + 22);
  WSAEMFILE          =  (WSABASEERR + 24);

  WSAEWOULDBLOCK     =  (WSABASEERR + 35);
  WSAEINPROGRESS     =  (WSABASEERR + 36);
  WSAEALREADY        =  (WSABASEERR + 37);
  WSAENOTSOCK        =  (WSABASEERR + 38);
  WSAEDESTADDRREQ    =  (WSABASEERR + 39);
  WSAEMSGSIZE        =  (WSABASEERR + 40);
  WSAEPROTOTYPE      =  (WSABASEERR + 41);
  WSAENOPROTOOPT     =  (WSABASEERR + 42);
  WSAEPROTONOSUPPORT =  (WSABASEERR + 43);
  WSAESOCKTNOSUPPORT =  (WSABASEERR + 44);
  WSAEOPNOTSUPP      =  (WSABASEERR + 45);
  WSAEPFNOSUPPORT    =  (WSABASEERR + 46);
  WSAEAFNOSUPPORT    =  (WSABASEERR + 47);
  WSAEADDRINUSE      =  (WSABASEERR + 48);
  WSAEADDRNOTAVAIL   =  (WSABASEERR + 49);
  WSAENETDOWN        =  (WSABASEERR + 50);
  WSAENETUNREACH     =  (WSABASEERR + 51);
  WSAENETRESET       =  (WSABASEERR + 52);
  WSAECONNABORTED    =  (WSABASEERR + 53);
  WSAECONNRESET      =  (WSABASEERR + 54);
  WSAENOBUFS         =  (WSABASEERR + 55);
  WSAEISCONN         =  (WSABASEERR + 56);
  WSAENOTCONN        =  (WSABASEERR + 57);
  WSAESHUTDOWN       =  (WSABASEERR + 58);
  WSAETOOMANYREFS    =  (WSABASEERR + 59);
  WSAETIMEDOUT       =  (WSABASEERR + 60);
  WSAECONNREFUSED    =  (WSABASEERR + 61);
  WSAELOOP           =  (WSABASEERR + 62);
  WSAENAMETOOLONG    =  (WSABASEERR + 63);
  WSAEHOSTDOWN       =  (WSABASEERR + 64);
  WSAEHOSTUNREACH    =  (WSABASEERR + 65);
  WSAENOTEMPTY       =  (WSABASEERR + 66);
  WSAEPROCLIM        =  (WSABASEERR + 67);
  WSAEUSERS          =  (WSABASEERR + 68);
  WSAEDQUOT          =  (WSABASEERR + 69);
  WSAESTALE          =  (WSABASEERR + 70);
  WSAEREMOTE         =  (WSABASEERR + 71);

  WSASYSNOTREADY     =  (WSABASEERR + 91);
  WSAVERNOTSUPPORTED =  (WSABASEERR + 92);
  WSANOTINITIALISED  =  (WSABASEERR + 93);

  WSAEDISCON         =  (WSABASEERR + 101);

  WSAHOST_NOT_FOUND  =  (WSABASEERR + 1001);
  WSATRY_AGAIN       =  (WSABASEERR + 1002);
  WSANO_RECOVERY     =  (WSABASEERR + 1003);
  WSANO_DATA         =  (WSABASEERR + 1004);

  HOST_NOT_FOUND     =  WSAHOST_NOT_FOUND;
  TRY_AGAIN          =  WSATRY_AGAIN;
  NO_RECOVERY        =  WSANO_RECOVERY;
  NO_DATA            =  WSANO_DATA;

  WSANO_ADDRESS      =  WSANO_DATA;
  NO_ADDRESS         =  WSANO_ADDRESS;

  EWOULDBLOCK        =  WSAEWOULDBLOCK;
  EINPROGRESS        =  WSAEINPROGRESS;
  EALREADY           =  WSAEALREADY;
  ENOTSOCK           =  WSAENOTSOCK;
  EDESTADDRREQ       =  WSAEDESTADDRREQ;
  EMSGSIZE           =  WSAEMSGSIZE;
  EPROTOTYPE         =  WSAEPROTOTYPE;
  ENOPROTOOPT        =  WSAENOPROTOOPT;
  EPROTONOSUPPORT    =  WSAEPROTONOSUPPORT;
  ESOCKTNOSUPPORT    =  WSAESOCKTNOSUPPORT;
  EOPNOTSUPP         =  WSAEOPNOTSUPP;
  EPFNOSUPPORT       =  WSAEPFNOSUPPORT;
  EAFNOSUPPORT       =  WSAEAFNOSUPPORT;
  EADDRINUSE         =  WSAEADDRINUSE;
  EADDRNOTAVAIL      =  WSAEADDRNOTAVAIL;
  ENETDOWN           =  WSAENETDOWN;
  ENETUNREACH        =  WSAENETUNREACH;
  ENETRESET          =  WSAENETRESET;
  ECONNABORTED       =  WSAECONNABORTED;
  ECONNRESET         =  WSAECONNRESET;
  ENOBUFS            =  WSAENOBUFS;
  EISCONN            =  WSAEISCONN;
  ENOTCONN           =  WSAENOTCONN;
  ESHUTDOWN          =  WSAESHUTDOWN;
  ETOOMANYREFS       =  WSAETOOMANYREFS;
  ETIMEDOUT          =  WSAETIMEDOUT;
  ECONNREFUSED       =  WSAECONNREFUSED;
  ELOOP              =  WSAELOOP;
  ENAMETOOLONG       =  WSAENAMETOOLONG;
  EHOSTDOWN          =  WSAEHOSTDOWN;
  EHOSTUNREACH       =  WSAEHOSTUNREACH;
  ENOTEMPTY          =  WSAENOTEMPTY;
  EPROCLIM           =  WSAEPROCLIM;
  EUSERS             =  WSAEUSERS;
  EDQUOT             =  WSAEDQUOT;
  ESTALE             =  WSAESTALE;
  EREMOTE            =  WSAEREMOTE;

{ dWinsock error values -- Used to lookup Strings in dwsError.Res }
  DWSErrAsyncAddrToHost    = DWSBaseErr +  1;
  DWSErrAsyncGetHostByAddr = DWSBaseErr +  2;
  DWSErrAsyncGetHostByName = DWSBaseErr +  3;
  DWSErrAsyncGetServByName = DWSBaseErr +  4;
  DWSErrAsyncGetServByPort = DWSBaseErr +  5;
  DWSErrAsyncHostToAddr    = DWSBaseErr +  6;
  DWSErrBind               = DWSBaseErr +  7;
  DWSErrConnect            = DWSBaseErr +  8;
  DWSErrCreate             = DWSBaseErr +  9;
  DWSErrGetPeerName        = DWSBaseErr + 10;
  DWSErrGetSockName        = DWSBaseErr + 11;
  DWSErrInCount            = DWSBaseErr + 12;
  DWSErrListen             = DWSBaseErr + 13;
  DWSErrRecv               = DWSBaseErr + 14;
  DWSErrSend               = DWSBaseErr + 15;
  DWSErrStart              = DWSBaseErr + 16;
  DWSErrNoAddress          = DWSBaseErr + 17;
  DWSErrSockNotOpen        = DWSBaseErr + 18;
  DWSErrBasAddress         = DWSBaseErr + 19;
  DWSErrSockAlreadyOpen    = DWSBaseErr + 20;
  DWSErrDatagramTooBig     = DWSBaseErr + 21;
  DWSErrDLLAlreadyLoaded   = DWSBaseErr + 22;
  DWSErrInvalidStreamType  = DWSBaseErr + 23;
  DWSErrInvalidDgramType   = DWSBaseErr + 24;
  DWSErrPeek               = DWSBaseErr + 25;
  DWSErrNoClass            = DWSBaseErr + 26;
  
implementation

end.
