unit Mainform;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, NWCK32DP, ExtCtrls, AddAddr, ComCtrls;

const
  SMTP_MAIL = WM_USER + 1;

type
  TDelphiMainForm = class(TForm)
    SendMessage: TBitBtn;
    Label1: TLabel;
    SenderEMail: TEdit;
    ToListGroup: TGroupBox;
    ToList: TListBox;
    AddTo: TButton;
    DeleteTo: TButton;
    CCListGroup: TGroupBox;
    CCList: TListBox;
    AddCC: TButton;
    DeleteCC: TButton;
    MessageGroup: TGroupBox;
    Subject: TEdit;
    Label2: TLabel;
    Panel1: TPanel;
    Label4: TLabel;
    StatusValue: TLabel;
    Label5: TLabel;
    ServerName: TEdit;
    OpenDialog: TOpenDialog;
    PageControl1: TPageControl;
    MessagePage: TTabSheet;
    Message: TMemo;
    FileAttachments: TTabSheet;
    FileList: TListBox;
    AddFile: TButton;
    DeleteFile: TButton;
    procedure SendMessageClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DeleteToClick(Sender: TObject);
    procedure DeleteCCClick(Sender: TObject);
    procedure AddCCClick(Sender: TObject);
    procedure DeleteFileClick(Sender: TObject);
    procedure AddFileClick(Sender: TObject);
  private
    { Private declarations }
    SMTPHandle : LongInt;

    procedure SMTPMAIL(var Message : TMessage); message SMTP_MAIL;
    procedure ValidateList(List : TListBox);
  public
    { Public declarations }
  end;

var
  DelphiMainForm: TDelphiMainForm;

implementation

{$R *.DFM}

procedure TDelphiMainForm.SMTPMAIL(var Message : TMessage);
begin
  StatusValue.Font.Color := clRed;

  case Message.WParam of
    SMTP_SHUTDOWN       : if (SMTPHandle <> 0) then
                           begin
                             NWCKSMTPClose(SMTPHandle);
                             StatusValue.Caption    := 'Shutting Down SMTP Service.';
                             StatusValue.Font.Color := clBlack;
                           end;
    SMTP_MEMORY_ERR     : StatusValue.Caption := 'Low memory problems';
    SMTP_READ_ERR       : StatusValue.Caption := 'Winsock read error';
    SMTP_WRITE_ERR	: StatusValue.Caption := 'Winsock write error';
    SMTP_NOCONN_ERR	: StatusValue.Caption := 'Not able to connect to SMTP Server';
    SMTP_RESPONSE_ERR	: StatusValue.Caption := 'SMTP returned an ERROR as a response';
    SMTP_FILEOPEN_ERR	: StatusValue.Caption := 'General File I/O unable to open file';
    SMTP_FILEREAD_ERR	: StatusValue.Caption := 'General File I/O read error';
    SMTP_NOMSG_ERR	: StatusValue.Caption := 'There were no messages to send';
    SMTP_WINCREAT_ERR	: StatusValue.Caption := 'Unable to create hidden window';
    SMTP_NOSERVNAM_ERR	: StatusValue.Caption := 'Not a valid SMTP Server Name';
    SMTP_SOCKCREAT_ERR	: StatusValue.Caption := 'Unable to create a stream socket';
    SMTP_SERVDISCON_ERR	: StatusValue.Caption := 'Server disconnected us';
    SMTP_NOSENDER_ERR	: StatusValue.Caption := 'Sender''s E-Mail address not in file';
    SMTP_FILEFORMAT_ERR	: StatusValue.Caption := 'The send file(MIME created) format is bad';
    SMTP_MAILSENT_NUM	: begin
                            StatusValue.Caption    := Format('Sent %d messages OK.', [Message.LParam]);
                            StatusValue.Font.Color := clGreen;
                          end;
    SMTP_MAILRCPT_ERR	: StatusValue.Caption := 'There was a bad Recipient Name.';
    SMTP_CONNECT_OK	: StatusValue.Caption := 'Connected to SMTP Server - OK';
    SMTP_MAILSENT_OK	: begin
                            StatusValue.Caption := ' All Mail was sent successfully';
                            StatusValue.Font.Color := clGreen;
                          end;
  end; { case }
end;

procedure TDelphiMainForm.ValidateList(List : TListBox);
begin
  if (List = ToList) then
    DeleteTo.Enabled := (List.Items.Count > 0)
  else if (List = CCList) then
    DeleteCC.Enabled := (List.Items.Count > 0)
  else if (List = FileList) then
    DeleteFile.Enabled := (List.Items.Count > 0);
end;

{ Delphi Defined }

procedure TDelphiMainForm.SendMessageClick(Sender: TObject);
var
  MIMEHandle                     : LongInt;
  OutFile, FromEMail, TempString : array[0..255] of char;
  Index                          : Integer;
  Buffer: PChar;
  Size: Byte;
begin
  StrPCopy(OutFile, 't$0001.mai');
  StrPCopy(FromEMail, SenderEMail.Text);
  MIMEHandle := 0;

  if (NWCKMIMEPrepStart(OutFile, FromEMail, MIMEHandle) = 0) then
   begin
     NWCKMIMEPrepNewMesg(MIMEHandle);

     { To List }
     for Index := 0 to (ToList.Items.Count-1) do
      begin
        StrPCopy(TempString, ToList.Items[Index]);
        NWCKMIMEPrepTo(MIMEHandle, TempString);
      end;

     { CC List }
     for Index := 0 to (CCList.Items.Count-1) do
      begin
        StrPCopy(TempString, CCList.Items[Index]);
        NWCKMIMEPrepCC(MIMEHandle, TempString);
      end;

     { File Attachments }
     for Index := 0 to (FileList.Items.Count-1) do
      begin
        StrPCopy(TempString, FileList.Items[Index]);
        NWCKMIMEPrepFile(MIMEHandle, TempString);
      end;

     StrPCopy(TempString, Subject.Text);
     NWCKMIMEPrepSubj(MIMEHandle, TempString);

     Size := Message.GetTextLen;       {Get length of string in Edit1}
     Inc(Size);                        {Add room for null character}
     GetMem(Buffer, Size);             {Creates Buffer dynamic variable}
     Message.GetTextBuf(Buffer, Size); {Puts Edit1.Text into Buffer}

     NWCKMIMEPrepData(MIMEHandle, Buffer, Size);
     FreeMem(Buffer, Size);            {Frees memory allocated to Buffer}
     NWCKMIMEPrepEndMesg(MIMEHandle);
     NWCKMIMEPrepFinish(MIMEHandle);

     { Send the Mail }
     NWCKSMTPStartWindow(Handle, SMTP_MAIL, OutFile, SMTPHandle);

     if(SMTPHandle <> 0) then
      begin
        StrPCopy(TempString, ServerName.Text);
        NWCKSMTPSendMail(SMTPHandle, TempString);
      end;
   end;
end;

procedure TDelphiMainForm.FormCreate(Sender: TObject);
begin
  SMTPHandle := 0;
end;

procedure TDelphiMainForm.DeleteToClick(Sender: TObject);
begin
  if (TOList.ItemIndex >= 0) then
    TOList.Items.Delete(TOList.ItemIndex);
  ValidateList(ToList);
end;

procedure TDelphiMainForm.DeleteCCClick(Sender: TObject);
begin
  if (CCList.ItemIndex >= 0) then
    CCList.Items.Delete(CCList.ItemIndex);
  ValidateList(CCList);
end;

procedure TDelphiMainForm.AddCCClick(Sender: TObject);
var List : TListBox;
begin
  if (Sender = AddCC) then List := CCList
  else if (Sender = AddTo) then List := ToList
  else List := NIL;

  if (List <> NIL) then
   try
     AddAddressDialog := TAddAddressDialog.Create(Self);

     if (AddAddressDialog.ShowModal = mrOk) then
       List.ItemIndex := List.Items.Add(AddAddressDialog.AddAddress.Text);
   finally
     AddAddressDialog.Free;
   end;

  ValidateList(List);
end;

procedure TDelphiMainForm.DeleteFileClick(Sender: TObject);
begin
  if (FileList.ItemIndex >= 0) then
    FileList.Items.Delete(FileList.ItemIndex);
  ValidateList(FileList);
end;

procedure TDelphiMainForm.AddFileClick(Sender: TObject);
begin
  if (FileList.Items.Count >= 8) then
    MessageDlg('You can only have 8 file attachments per message.', mtWarning,
               [mbOk], 0)
  else if OpenDialog.Execute then
    FileList.ItemIndex := FileList.Items.Add(OpenDialog.FileName);

  ValidateList(FileList);
end;

end.
