unit mainpop3;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, NWCK32DP, ExtCtrls, ComCtrls;

const
  POP3_MAIL = WM_USER + 1;

type
  TDelphiPOP3Form = class(TForm)
    ToListGroup: TGroupBox;
    MessageToList: TListBox;
    CCListGroup: TGroupBox;
    MessageCCList: TListBox;
    MessageGroup: TGroupBox;
    MessageSubject: TEdit;
    Label2: TLabel;
    Panel1: TPanel;
    Label4: TLabel;
    StatusValue: TLabel;
    Label5: TLabel;
    ServerName: TEdit;
    PageControl1: TPageControl;
    MessagePage: TTabSheet;
    Message: TMemo;
    FileAttachments: TTabSheet;
    MessageFileList: TListBox;
    PullMessage: TBitBtn;
    Bevel1: TBevel;
    UserName: TEdit;
    Label1: TLabel;
    Password: TEdit;
    Label3: TLabel;
    FirstMessage: TBitBtn;
    NextMessage: TBitBtn;
    Label6: TLabel;
    MessageDate: TLabel;
    Label7: TLabel;
    MessageFrom: TLabel;
    procedure PullMessageClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FirstMessageClick(Sender: TObject);
    procedure NextMessageClick(Sender: TObject);
  private
    { Private declarations }
    POP3Handle, MIMEHandle        : LongInt;
    TotalMessages, CurrentMessage : Integer;

    procedure POP3MAIL(var Message : TMessage); message POP3_MAIL;
    procedure SetMessage(InMessage : PNWCKMIMEMSG);
  public
    { Public declarations }
  end;

var
  DelphiPOP3Form: TDelphiPOP3Form;

implementation

{$R *.DFM}

const
  ReceiveFile = '____rcvc.txt';

procedure TDelphiPOP3Form.POP3MAIL(var Message : TMessage);
begin
  StatusValue.Font.Color := clRed;

  case Message.WParam of
    POP3_SHUTDOWN       : if (POP3Handle <> 0) then
                           begin
                             NWCKPOP3Close(POP3Handle);
                             StatusValue.Caption    := 'Shutting Down POP3 Service.';
                             StatusValue.Font.Color := clBlack;
                           end;
    POP3_MEMORY_ERR     : StatusValue.Caption := 'Low memory problems';
    POP3_READ_ERR       : StatusValue.Caption := 'Winsock read error';
    POP3_WRITE_ERR	: StatusValue.Caption := 'Winsock write error';
    POP3_NOCONN_ERR	: StatusValue.Caption := 'Not able to connect to POP3 Server';
    POP3_RESPONSE_ERR	: StatusValue.Caption := 'POP3 returned an ERROR as a response';
    POP3_FILEOPEN_ERR	: StatusValue.Caption := 'General File I/O unable to open file';
    POP3_FILEREAD_ERR	: StatusValue.Caption := 'General File I/O read error';
    POP3_FILEWRIT_ERR	: StatusValue.Caption := 'General File I/O write error';
    POP3_NOMSG_ERR	: StatusValue.Caption := 'There were no messages to send';
    POP3_WINCREAT_ERR	: StatusValue.Caption := 'Unable to create hidden window';
    POP3_NOSERVNAM_ERR	: StatusValue.Caption := 'Not a valid POP3 Server Name';
    POP3_SOCKCREAT_ERR	: StatusValue.Caption := 'Unable to create a stream socket';
    POP3_SERVDISCON_ERR	: StatusValue.Caption := 'Server disconnected us';
    POP3_NOUSERNAM_ERR	: StatusValue.Caption := 'No Username specified';
    POP3_NOPWORD_ERR	: StatusValue.Caption := 'Not a valid password';
    POP3_RTRVNG_MSG     : begin
                            StatusValue.Caption := Format('Recieving Message %d.', [Message.LParam]);
                            StatusValue.Font.Color := clGreen;
                          end;
    POP3_TOTALMAIL_MSG	: begin
                            StatusValue.Caption    := Format('There are %d messages for you.', [Message.LParam]);
                            StatusValue.Font.Color := clGreen;
                            TotalMessages        := Message.LParam;
                            FirstMessage.Enabled := (TotalMessages > 0);
                            NextMessage.Enabled  := (TotalMessages > 1);
                          end;
    POP3_CONNECT_OK	: begin
                            StatusValue.Caption := 'Connected to POP3 Server - OK';
                            StatusValue.Font.Color := clGreen;
                          end;
    POP3_MAILRTRV_OK	: begin
                            StatusValue.Caption := ' All mail was received successfully';
                            StatusValue.Font.Color := clGreen;
                          end;
  end; { case }
end;

procedure TDelphiPOP3Form.SetMessage(InMessage : PNWCKMIMEMSG);
var Index : integer;
begin
  if (InMessage <> NIL) then
    with InMessage^ do
     begin
       MessageDate.Caption := StrPas(@DateString);
       MessageFrom.Caption := StrPas(@FromString);
       MessageSubject.Text := StrPas(@SubjectString);
       MessageToList.Items.Clear;

       for Index := 1 to ToNumber do
         MessageToList.Items.Add(StrPas(ToList[Index]));

       MessageCCList.Items.Clear;
       for Index := 1 to CCNumber do
         MessageCCList.Items.Add(StrPas(CCList[Index]));

       MessageFileList.Items.Clear;
       for Index := 1 to FileNumber do
         MessageFileList.Items.Add(StrPas(FileAttachments[Index]));

       Message.SetTextBuf(DataString);
     end;
end;

{ Delphi Defined }

procedure TDelphiPOP3Form.PullMessageClick(Sender: TObject);
var
  aServerName, aUserName, aPassword : array[0..255] of char;
begin
  { Pull the Mail }
  if (MIMEHandle <> 0) then NWCKMIMEScanClose(MIMEHandle);
  MIMEHandle := 0;

  NWCKPOP3StartWindow(Handle, POP3_MAIL, ReceiveFile, POP3Handle);

  if(POP3Handle <> 0) then
   begin
     StrPCopy(aServerName, ServerName.Text);
     StrPCopy(aUserName, UserName.Text);
     StrPCopy(aPassword, Password.Text);
     NWCKPOP3PullMail(POP3Handle, aServerName, aUserName, aPassword, FALSE);
     if FirstMessage.Enabled then FirstMessage.Click;
   end;
end;

procedure TDelphiPOP3Form.FormCreate(Sender: TObject);
begin
  POP3Handle     := 0;
  MIMEHandle     := 0;
  TotalMessages  := 0;
  CurrentMessage := 0;
end;

procedure TDelphiPOP3Form.FormDestroy(Sender: TObject);
begin
  if (MIMEHandle <> 0) then
    NWCKMIMEScanClose(MIMEHandle);
end;

procedure TDelphiPOP3Form.FirstMessageClick(Sender: TObject);
begin
  CurrentMessage := 1;

  if (MIMEHandle = 0) then NWCKMIMEScanStart(ReceiveFile, '', MIMEHandle);
  NWCKMIMEScanNumMessages(MIMEHandle, TotalMessages);

  SetMessage(NWCKMIMEScanGetFirst(MIMEHandle));
  FirstMessage.Enabled := FALSE;
end;

procedure TDelphiPOP3Form.NextMessageClick(Sender: TObject);
begin
  if (CurrentMessage < TotalMessages) then
   begin
     SetMessage(NWCKMIMEScanGetNext(MIMEHandle));
     Inc(CurrentMessage);
   end;

  NextMessage.Enabled := (CurrentMessage < TotalMessages);
end;

end.
